/// <reference types="node" />
import { ClientTransport, Closeable, Demultiplexer, DuplexConnection, FrameHandler, Multiplexer, Outbound } from "rsocket-core";
import net from "net";
declare type TcpClientOptionsSocketFactory = (options: net.NetConnectOpts) => net.Socket;
declare type TcpClientOptions = {
    connectionOptions: net.NetConnectOpts;
    socketCreator?: TcpClientOptionsSocketFactory;
};
export declare class TcpClientTransport implements ClientTransport {
    private readonly connectionOptions;
    private readonly socketCreator;
    constructor(options: TcpClientOptions);
    connect(multiplexerDemultiplexerFactory: (outbound: Outbound & Closeable) => Multiplexer & Demultiplexer & FrameHandler): Promise<DuplexConnection>;
}
export {};
